// vMac 0.x Source
// By Philip Cummins (PC)
// Copyright PC 1997
   
/* PC - IWM Header File */

// This is the emulation for the IWM, the Integrated Woz Machine. It's basically
// a serial to parallel converter with some timing in-built into it to perform
// handshaking. Emulation so far just includes Status and Mode Register Accesses.

#define kIWM_Size 0x002000 // Allocated Memory Bandwidth for IWM
#define kIWM_Base 0xDFE1FF // IWM Memory Base

#define kIWM_Block_Base 0xC00000 // IWM Block Start
#define kIWM_Block_Top  0xE00000 // IWM Block End

#define kph0L     0x00 // CA0 off (0)
#define kph0H     0x01 // CA0 on (1)
#define kph1L     0x02 // CA1 off (0)
#define kph1H     0x03 // CA1 on (1)
#define kph2L     0x04 // CA2 off (0)
#define kph2H     0x05 // CA2 on (1)
#define kph3L     0x06 // LSTRB off (low)
#define kph3H     0x07 // LSTRB on (high)
#define kmtrOff   0x08 // disk enable off
#define kmtrOn    0x09 // disk enable on
#define kintDrive 0x0A // select internal drive
#define kextDrive 0x0B // select external drive
#define kq6L      0x0C // Q6 off
#define kq6H      0x0D // Q6 on
#define kq7L      0x0E // Q7 off
#define kq7H      0x0F // Q7 on

#define kph0 0x01
#define kph1 0x02
#define kph2 0x04
#define kph3 0x08
#define kmtr 0x10
#define kdrv 0x20
#define kq6  0x40
#define kq7  0x80

typedef struct
{
  UBYTE DataIn;    // Read Data Register
  UBYTE Handshake; // Read Handshake Register
  UBYTE Status;    // Read Status Register
  UBYTE Mode;      // Drive Off : Write Mode Register
                   // Drive On  : Write Data Register
  UBYTE DataOut;   // Write Data Register
  UBYTE Lines;     // Used to Access Disk Drive Registers
} IWM_Ty;

typedef enum {On, Off} Mode_Ty;

int   IWM_Init (void);
void  IWM_Reset (void);

UBYTE IWM_GetB (CPTR addr);
UWORD IWM_GetW (CPTR addr);
ULONG IWM_GetL (CPTR addr);

void  IWM_PutB (CPTR addr, UBYTE in);
void  IWM_PutW (CPTR addr, UWORD in);
void  IWM_PutL (CPTR addr, ULONG in);

void  IWM_Update    (void);
UBYTE IWM_Read_Reg  (void);
void  IWM_Write_Reg (UBYTE in);
void  IWM_Set_Lines (UBYTE line, Mode_Ty mode);

// VIA Interface Headers

UBYTE VIA_GORA5 (void); // Floppy Disk Line SEL
void  VIA_PORA5 (UBYTE Data);

//IRIX CC needs a little new-line at the end of include files.

