// vMac 0.1 Source
// By Philip Cummins (PC)
// Copyright PC 1997
   
// PC - RAM Function Files

#include "sysconfig.h"
#include "sysdeps.h"
#include "config.h"
#include "RAM.h"
#	ifdef _RAM_Debug
#include <stdio.h>
#	endif
#include "prefs.h"
#include "Memory.h"

//UWORD RAM [kRAM_Size/2];
UWORD *RAM = NULL;
ULONG kRAM_Size = 0; 
UBYTE oldRAMSize=255;

int  RAM_Init (void)
{	
	if (oldRAMSize==255) oldRAMSize=thePrefs.RAMSize;

	if (thePrefs.RAMSize == 4)
	{
		kRAM_Size = 0x00400000;
		RAM = (UWORD *)calloc(1, kRAM_Size); // Try 4 MB
		if (RAM != NULL)
		{
			thePrefs.RAMSize=oldRAMSize;
			return 0;
		}
		else
		{
			printf("There is not enough memory available to allocate 4Mb of RAM for the emulated Mac. 2Mb of RAM will be allocated instead.\n");
			thePrefs.RAMSize=2;
			return RAM_Init();
		}	
	}
	else if (thePrefs.RAMSize == 2)
	{
		kRAM_Size = 0x00200000;
		RAM = (UWORD *)calloc(1, kRAM_Size); // Try 2 MB
		if (RAM != NULL)
		{
			thePrefs.RAMSize=oldRAMSize;
			return 0;
   		}
   		else
    		{
			printf("There is not enough memory available to allocate 2Mb of RAM for the emulated Mac. 1Mb of RAM will be allocated instead.\n");
			thePrefs.RAMSize=1;
			return RAM_Init();
		}
	}
	else if (thePrefs.RAMSize == 1)
	{
		kRAM_Size = 0x00100000;
		RAM = (UWORD *)calloc(1, kRAM_Size); // Try 1 MB
		if (RAM != NULL)
		{
  			thePrefs.RAMSize=oldRAMSize;
   			return 0;
		}
		else
		{
			printf("There is not enough memory available to allocate 1Mb of RAM for the emulated Mac.\n");
		}
	}
	thePrefs.RAMSize=oldRAMSize;
	return 1;
}

void  RAM_Reset (void)
{
	;
}

UWORD *RAM_Xlate (CPTR addr)
{
  CPTR taddr = addr & kMemory_Extent;
  return (RAM + (taddr >> 1));
}

UBYTE RAM_GetB (CPTR addr)
{
  CPTR taddr = addr & kMemory_Extent;
  return RAM [taddr >> 1] >> (taddr & 1 ? 0 : 8);
}

UWORD RAM_GetW (CPTR addr)
{
  CPTR taddr = addr & kMemory_Extent;
  return RAM [taddr >> 1];
}

ULONG RAM_GetL (CPTR addr)
{
  CPTR taddr = addr & kMemory_Extent;
  return ((ULONG) RAM [taddr >> 1] << 16) | RAM [(taddr >> 1)+1];
}

void  RAM_PutB (CPTR addr, UBYTE in)
{
  CPTR taddr = addr & kMemory_Extent;
  if (!(taddr & 1))
  {
    RAM [taddr >> 1] = (RAM [taddr >> 1] & 0xff) | (((UWORD) in) << 8);
  }
  else
  {
    RAM [taddr >> 1] = (RAM [taddr >> 1] & 0xff00) | in;
  }
}

void  RAM_PutW (CPTR addr, UWORD in)
{
  CPTR taddr = addr & kMemory_Extent;
  RAM [taddr >> 1] = in;
}

void  RAM_PutL (CPTR addr, ULONG in)
{
  CPTR taddr = addr & kMemory_Extent;
  RAM [taddr >> 1] = in >> 16;
  RAM [(taddr >> 1) + 1] = (UWORD) in;
}
