// vMac 0.x Source
// By Philip Cummins (PC)
// Copyright PC 1997
   
// PC - ROM Function Files

#include "sysconfig.h"
#include "sysdeps.h"
#include "config.h"
#include "ROM.h"
#include "prefs.h"
#ifdef _ROM_Debug
#include <stdio.h>
#endif

UWORD ROM [kROM_Size/2];

int  ROM_Init (void)
{
  FILE *ROM_File;
  int  File_Size;
  int i;
  char *text = "Loading vMac.ROM...";

  ROM_File = fopen(thePrefs.ROMPath[thePrefs.CurrentROMPath], "rb");
  if (ROM_File == NULL) ROM_File = fopen("vMac.ROM","rb");
  
  if (ROM_File == NULL)
  { 
    printf("The vMac.ROM could not be found.\n");
    return 1;
  }
  File_Size = fread(ROM, kROM_Size, 1, ROM_File);

  printf("%s\n", text);

  if (File_Size != 1)
  {
    printf("The vMac.ROM is not 128 KB.\n");
    fclose(ROM_File);
    return 1;
  }
  fclose(ROM_File);
#if FIXEND
  for (i = 0; i < kROM_Size/2; i++) {
      UWORD *p = ROM + i;
      UBYTE *bp = (UBYTE *)p;
      *p = (*bp << 8) | *(bp+1);
  }
#endif
  if ((ROM[0] == 0x4D1E) && (ROM[1] == 0xEEE1))
  {
    printf("vMac.ROM loaded successfully, Mac Plus ROM v 1, 'Lonely Hearts'.\n");
    return 0;
  }
  if ((ROM[0] == 0x4D1E) && (ROM[1] == 0xEAE1))
  {
    printf("vMac.ROM loaded successfully, Mac Plus ROM v 2, 'Lonely Heifers'.\n");
    return 0;
  }
  if ((ROM[0] == 0x4D1F) && (ROM[1] == 0x8172))
  {
    char *text2 = "vMac.ROM loaded successfully, Mac Plus ROM v 3, 'Loud Harmonicas'.";
    printf("%s\n", text2);
    return 0;
  }
  printf("vMac.ROM loaded successfully, but we don't support this ROM yet.\n");
  return 1;
}

void  ROM_Reset (void)
{
  extern UBYTE Sony_Installed;
  
  if (Sony_Installed == 1)
    (void) ROM_Init();
}

UWORD *ROM_Xlate (CPTR addr)
{
  return ROM + (addr >> 1);
}

UBYTE ROM_GetB (CPTR addr)
{
  return ROM [addr >> 1] >> (addr & 1 ? 0 : 8);
}

UWORD ROM_GetW (CPTR addr)
{
  return ROM [addr >> 1];
}

ULONG ROM_GetL (CPTR addr)
{
  return ((ULONG) ROM [addr >> 1] << 16) | ROM [(addr >> 1) + 1];
}

void  ROM_PutB (CPTR addr, UBYTE in)
{
	;
}

void  ROM_PutW (CPTR addr, UWORD in)
{
	;
}

void  ROM_PutL (CPTR addr, ULONG in)
{
	;
}
