// vMac 0.x Source
// By Philip Cummins (PC)
// Copyright PC 1997
   
// PC - RTC (Real Time Clock) Headers

typedef struct
{

  // RTC VIA Flags
  UBYTE Enabled;
  UBYTE Clock;
  
  // RTC Data
  UBYTE Mode;
  UBYTE Command;
  UBYTE Data;
  UBYTE Counter;
  
  // RTC Registers
  UBYTE Seconds_1[4]; // Apple Documented Seconds
  UBYTE Seconds_2[4]; // Unknown (apparent) second Seconds backup
  UBYTE RAM[20];
  
} RTC_Ty;

int   RTC_Init (void);
void  Set_RTC_Time (void);
void  RTC_Reset (void);
void  RTC_Interrupt (void);

void  RTC_Put (UBYTE in);
UBYTE RTC_Get (void);

void RTC_DoCmd     (void);
void RTC_Read_Reg  (void);
void RTC_Write_Reg (void);

// RTC File Access Functions

UBYTE RTC_Load (void);
void  RTC_Save (void);

// VIA Interface Functions

UBYTE VIA_GORB2 (void); // RTC Enable
void  VIA_PORB2 (UBYTE Data);

UBYTE VIA_GORB1 (void); // RTC Data Clock
void  VIA_PORB1 (UBYTE Data);

UBYTE VIA_GORB0 (void); // RTC Data
void  VIA_PORB0 (UBYTE Data);

//IRIX CC needs a little new-line at the end of include files.


