// PC - Sound Functions

#include "sysconfig.h"
#include "sysdeps.h"
#include "config.h"
#include "Sound.h"
#	ifdef _Sound_Debug
#include <stdio.h>
#	endif

// Local Variables

static Sound_Ty Sound;

// VIA Interface Functions

UBYTE VIA_GORA3 (void) // Main/Alternate Sound Buffer
{
#	ifdef _VIA_Interface_Debug
  printf("VIA ORA3 attempts to be an input\n");
#	endif
  return 0;
}

void  VIA_PORA3 (UBYTE Data)
{
  Sound.Buffer = Data; // 1 = Main, 0 = Alternate
}

UBYTE VIA_GORA2 (void) // Sound Volume Bit 2
{
#	ifdef _VIA_Interface_Debug
  printf("VIA ORA2 attempts to be an input\n");
#	endif
  return 0;
}

void  VIA_PORA2 (UBYTE Data)
{
  if (Data == 0)
    { Sound.Volume &= 0x03; }
  else
    { Sound.Volume |= 0x04; }
}

UBYTE VIA_GORA1 (void) // Sound Volume Bit 1
{
#	ifdef _VIA_Interface_Debug
  printf("VIA ORA1 attempts to be an input\n");
#	endif
  return 0;
}

void  VIA_PORA1 (UBYTE Data)
{
  if (Data == 0)
    { Sound.Volume &= 0x05; }
  else
    { Sound.Volume |= 0x02; }
}

UBYTE VIA_GORA0 (void) // Sound Volume Bit 0
{
#	ifdef _VIA_Interface_Debug
  printf("VIA ORA0 attempts to be an input\n");
#	endif
	return 0;
}

void  VIA_PORA0 (UBYTE Data)
{
  if (Data == 0)
    { Sound.Volume &= 0x06; }
  else
    { Sound.Volume |= 0x01; }
}

UBYTE VIA_GORB7 (void) // Sound Enable
{
#	ifdef _VIA_Interface_Debug
  printf("VIA ORB7 attempts to be an input\n");
#	endif
  return 0;
}

void  VIA_PORB7 (UBYTE Data)
{
  Sound.Enable = Data; // 0 = Enabled, 1 = Disabled
}
