// PC - Sound Headers

typedef struct
{
  UBYTE Enable;
  UBYTE Volume;
  UBYTE Buffer;
} Sound_Ty;

#define kSnd_Main_Offset 	0x0300
#define kSnd_Alt_Offset 	0x5F00

#define kSnd_Main_Buffer (kRAM_Size - kSnd_Main_Offset)
#define kSnd_Alt_Buffer (kRAM_Size - kSnd_Alt_Offset)

int Audio_Init(void);
int Audio_Close(void);
void Audio_Update(void);

// VIA Interface Headers

UBYTE VIA_GORA3 (void); // Main/Alternate Sound Buffer
void  VIA_PORA3 (UBYTE Data);

UBYTE VIA_GORA2 (void); // Sound Volume Bit 2
void  VIA_PORA2 (UBYTE Data);

UBYTE VIA_GORA1 (void); // Sound Volume Bit 1
void  VIA_PORA1 (UBYTE Data);

UBYTE VIA_GORA0 (void); // Sound Volume Bit 0
void  VIA_PORA0 (UBYTE Data);

UBYTE VIA_GORB7 (void); // Sound Enable
void  VIA_PORB7 (UBYTE Data);

//IRIX CC needs a little new-line at the end of include files.

