// vMac 0.x Source
// By Philip Cummins (PC)
// Copyright PC 1997
   
// PC - VIA Memory Handlers

#define kVIA_Size 0x2000
#define kVIA_Base 0xEFE1FE

#define kVIA_Block_Base 0xE80000
#define kVIA_Block_Top  0xF00000

#define kORB    0x00
#define kORA_H  0x01
#define kDDR_B  0x02
#define kDDR_A  0x03
#define kT1C_L  0x04
#define kT1C_H  0x05
#define kT1L_L  0x06
#define kT1L_H  0x07
#define kT2_L   0x08
#define kT2_H   0x09
#define kSR     0x0A
#define kACR    0x0B
#define kPCR    0x0C
#define kIFR    0x0D
#define kIER    0x0E
#define kORA    0x0F

#define kSR_Init_Time 0x007F // Was 0x09C9, trying less

typedef struct
{

  UBYTE ORB;    // Buffer B
//UBYTE ORA_H;     Buffer A with Handshake
  UBYTE DDR_B;  // Data Direction Register B
  UBYTE DDR_A;  // Data Direction Register A
  UBYTE T1C_L;  // Timer 1 Counter Low
  UBYTE T1C_H;  // Timer 1 Counter High
  UBYTE T1L_L;  // Timer 1 Latch Low
  UBYTE T1L_H;  // Timer 1 Latch High
  UBYTE T2_L;   // Timer 2 Low
  UBYTE T2_H;   // Timer 2 High
  UBYTE SR;     // Shift Register
  UBYTE ACR;    // Auxiliary Control Register
  UBYTE PCR;    // Peripheral Control Register
  UBYTE IFR;    // Interrupt Flag Register
  UBYTE IER;    // Interrupt Enable Register
  UBYTE ORA;    // Buffer A

} VIA_Ty;

typedef enum
{
  T1,
  T2,
  CB1,
  CB2,
  SR,
  CA1,
//will this break horribly?
  CA2
} VIA_Interrupt_Ty;

int   VIA_Init (void);
void  VIA_Reset (void);

void VIA_Interrupt (VIA_Interrupt_Ty VIA_Int);

UBYTE VIA_GetB (CPTR addr);
UWORD VIA_GetW (CPTR addr);
ULONG VIA_GetL (CPTR addr);

void  VIA_PutB (CPTR addr, UBYTE in);
void  VIA_PutW (CPTR addr, UWORD in);
void  VIA_PutL (CPTR addr, ULONG in);

void VIA_Timer (void);

//IRIX CC needs a little new-line at the end of include files.

