 /*
  * vMac DSP Sound Interface
  * Copyright 1997 Michael Hanni (mhanni@sprintmail.com)
  */

/*
	WARNING!! This currently DOES NOT work! You can try it, but you won't
	get anything but weird noises.
*/

#include "sysconfig.h"
#include "sysdeps.h"

#include "config.h"
#include "options.h"
#include "memory.h"
#include "custom.h"
#include "Sound.h"
#include "RAM.h"
#include "prefs.h"

#include <unistd.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/ioctl.h>
#include <stdlib.h>
#include <stdio.h>
#include <sys/soundcard.h>


#define LENGTH		3
#define RATE		22254
#define SIZE		8
#define CHANNELS	1


// Local Variables

static Sound_Ty Sound;

ULONG kSound_Address;
UWORD kSound_Buffer[370];
UWORD Sound_Buffer[370];
char *kSound_To_Play;

int AudioDev;
int	fd, arg, status;
static unsigned long formats;

int Audio_Init(void)
{
	
	fd = open("/dev/dsp", O_RDWR);
	if (fd < 0) {
		perror("open of /dev/dsp failed.\n");
		exit(1);
	}
	
	arg = SIZE;
	status = ioctl(fd, SOUND_PCM_WRITE_BITS, &arg);
	if (status == -1)
		perror("ioctl of rate failed.\n");

	arg = CHANNELS;
	status = ioctl(fd, SOUND_PCM_WRITE_CHANNELS, &arg);
	if (status == -1)
		perror("ioctl of rate failed.\n");

	arg = RATE;
	status = ioctl(fd, SOUND_PCM_WRITE_RATE, &arg);
	if (status == -1)
		perror("ioctl of rate failed.\n");

	return 0;

}
                                                                    
int Audio_Close(void)
{
	close(fd);
	return 0;
}

void Audio_Update(void)
{
   int pos;

   if (Sound.Enable==0) {
      if (Sound.Buffer==0) {
         kSound_Address = kRAM_Size-0x5F00;
      } else {
         kSound_Address = kRAM_Size-0x300;
      }

      for (pos=0 ; pos<370 ; ++pos)
         kSound_Buffer[pos] = RAM_GetW(kSound_Address+pos);

      for (pos=0 ; pos<370 ; ++pos)
         Sound_Buffer[pos]  = ((kSound_Buffer[pos] & 0xFF00) >> 8);
  
      //SetVolume(Sound.Volume);
      //PlayBack();
   }

   write(fd, Sound_Buffer, sizeof(Sound_Buffer)/2);

}

// VIA Interface Functions

UBYTE VIA_GORA3 (void) // Main/Alternate Sound Buffer
{
#	ifdef _VIA_Interface_Debug
  printf("VIA ORA3 attempts to be an input\n");
#	endif
  return 0;
}

void  VIA_PORA3 (UBYTE Data)
{
  Sound.Buffer = Data; // 1 = Main, 0 = Alternate
}

UBYTE VIA_GORA2 (void) // Sound Volume Bit 2
{
#	ifdef _VIA_Interface_Debug
  printf("VIA ORA2 attempts to be an input\n");
#	endif
  return 0;
}

void  VIA_PORA2 (UBYTE Data)
{
  if (Data == 0)
    { Sound.Volume &= 0x03; }
  else
    { Sound.Volume |= 0x04; }
}

UBYTE VIA_GORA1 (void) // Sound Volume Bit 1
{
#	ifdef _VIA_Interface_Debug
  printf("VIA ORA1 attempts to be an input\n");
#	endif
  return 0;
}

void  VIA_PORA1 (UBYTE Data)
{
  if (Data == 0)
    { Sound.Volume &= 0x05; }
  else
    { Sound.Volume |= 0x02; }
}

UBYTE VIA_GORA0 (void) // Sound Volume Bit 0
{
  #ifdef _VIA_Interface_Debug
  printf("VIA ORA0 attempts to be an input\n");
  #endif
  return 0;
}

void  VIA_PORA0 (UBYTE Data)
{
  if (Data == 0)
    { Sound.Volume &= 0x06; }
  else
    { Sound.Volume |= 0x01; }
}

UBYTE VIA_GORB7 (void) // Sound Enable
{
  #ifdef _VIA_Interface_Debug
  printf("VIA ORB7 attempts to be an input\n");
  #endif
  return 0;
}

void  VIA_PORB7 (UBYTE Data)
{
  Sound.Enable = Data; // 0 = Enabled, 1 = Disabled
}
