/* vMac 0.1 Source
   By Philip Cummins (PC)
   Copyright PC 1997 */
   
/* vMac Custom Code */

#include <ctype.h>
#include <assert.h>
#include "sysconfig.h"
#include "sysdeps.h"
#include "config.h"
#include "custom.h"
#include "options.h"
#include "Memory.h"
#include "newcpu.h"

#include "RAM.h"
#include "ROM.h"
#include "IWM.h"
#include "VIA_Interrupts.h"
#include "SCC.h"
#include "SCSI.h"
#include "VIA.h"
#include "RTC.h"
#include "Screen.h"
#include "Sony.h"
#include "Sound.h"

unsigned long specialflags = 0;
int InterruptNo = -1;

int gui_init(void);

void MacInterrupt (void)
{	   
  //specialflags |= SPCFLAG_DOINT;
  //InterruptNo = 4;
  if (regs.intmask <= 4)
    Exception(28);
}

void MacReset (void)
{
  MC68000_reset();
}

int custominit (void)
{
  int Err = 0;
  Err += RAM_Init();
  Err += ROM_Init();
  Err += IWM_Init();
  Err += SCC_Init();
  Err += SCSI_Init();
  Err += VIA_Init();
  Err += RTC_Init();
  Err += Memory_Init();
  //Err += Screen_Init();
  //Err += Audio_Init();
  Err += Interrupt_Init();
  Err += Sony_Init();
  InterruptNo = -1;
  return Err;
}

void customreset (void)
{
  RAM_Reset();
  ROM_Reset();
  IWM_Reset();
  SCC_Reset();
  SCSI_Reset();
  VIA_Reset();
  RTC_Reset();
  Memory_Init();
  Screen_Reset();
  Interrupt_Reset();
  Sony_Reset();
  InterruptNo = -1;
}

int intlev (void)
{
  int value = InterruptNo;
  
  InterruptNo = -1;
  return value;
}
